function [PD,AD,SV,ASV,IPD,IP]=NL_F_Binning(k,l,d,s,ib)
	[lhs,rhs]=argn();
	lhsn=6;
	rhsn=5;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[pd,AD,SV,ASV,ipd] = NL_F_Binning(k,l,d,s,ib)";
		help('NL_F_Binning');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	PD=[];//pair distance
	IPD=[];//index pair distance
	AD=[];//average distance
	SV=[];//semivariance
	ASV=[];//average semivariance
	IP=[];//couple index from ib
	n=length(ib);
	for i=1:n-1
		ind=find((d>ib(i)) & (d<=ib(i+1)));
		PD=[PD d(ind)];
		AD=[AD mean(d(ind))];
		SV=[SV s(ind)];
		ASV=[ASV mean(s(ind))];
		IPD=[IPD length(ind)];
		IP=[IP ind];
	end
	ind=find(d>ib($));
	PD=[PD d(ind)];
	AD=[AD mean(d(ind))];
	SV=[SV s(ind)];
	ASV=[ASV mean(s(ind))];
	IPD=[IPD length(ind)];
	IP=[IP ind];
endfunction
