function [KK,VV] = NL_F_KrigingOrdinary(x,y,z,gx,gy,ni)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=6;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[KK,VV] = NL_F_KrigingOrdinary(x,y,z,gx,gy,ni)";
		help('NL_F_KrigingOrdinary');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	[k,l,d,s]=NL_F_SemiVariogram(x,y,z);
	n=length(x);
	KK=[];//vector of kriging predictor
	VV=[];//vector of krigind variance
	for ii=1:length(gx)
		//prediction for the point xi=gx(1) yi=gy(1)
		//ni=0.1;//inter slope increment between 0 and max slope
		[os,isl,di]=NL_F_SemiVariogramFit(s,d,ni);//os is the best slope
		[g]=NL_F_GammaMatrix(os,k,l,d,n);//gamma matrix
		xi=gx(ii);
		yi=gy(ii);
		[dv,gv]=NL_F_ForecastXY(g,os,x,y,xi,yi);//g vector:gv
		[lambda]=NL_F_ForecastLambda(g,gv);//lambda weight
		[P,K]=NL_F_KrigingPred(lambda,z);//kriging predictor P($)
		[sd,v]=NL_F_KrigingVar(lambda,gv);//kriging standard error
		KK=[KK K];
		VV=[VV v];
	end
endfunction
