function [M]=NL_F_VoronoiIncremental(nx,ny,Lx,Ly,Dpres)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=5;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[M]=NL_F_VoronoiIncremental(nx,ny,Lx,Ly,Dpres)";
		help('NL_F_VoronoiIncremental');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	n=length(nx);
	//sort node with increasing x and increasing y
	[nni nnj]=gsort(ny,'c','i');
	Y=ny(nnj);
	X=nx(nnj);	
	[nni nnj]=gsort(X,'c','i');
	Y=Y(nnj);
	X=X(nnj);
	M=zeros(n,2*(3*n-6)+1);//for n>=3, the number of vertice <= 2n-5 and the number of edge <= 3n-6 in (x,y):*2
	Pc=[0 0 0 1000 1000 1000 1000 0];			
	[ac,bc]=NL_F_Bisection(X(1),Y(1),X(2),Y(2));
	[I,IF]=NL_F_InterPolygonLine(Pc,ac,bc,Lx,Ly,Dpres);
	path=IF;
	//if first point and last point belongs to the rectangle border, stop: bool=%T
	pdebx=path(1);
	pdeby=path(2);
	pfinx=path($-1);
	pfiny=path($);
	[bdeb,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pdebx,pdeby,Dpres);
	[bfin,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pfinx,pfiny,Dpres);
	if (bdeb==%T)&(bfin==%T)
		bool=%T
	end
	Si=[IF(1:2);IF(3:4)];
	SiD=[IF(1:2);IF(3:4)];
	for k=1:length(Pc)/2
		scx=Pc(2*(k-1)+1);
		scy=Pc(2*k);
		dsi=NL_F_DistanceSiDj(X(1),Y(1),scx,scy);
		dsiD=NL_F_DistanceSiDj(X(2),Y(2),scx,scy);
		if (dsi<dsiD)
			Si=[Si;scx scy];
		else
			SiD=[SiD;scx scy];
		end
	end
	SSi=NL_V_GrahamScan(Si);
	SSiD=NL_V_GrahamScan(SiD);
	MSi=[];
	MSiD=[];	
	[lSSi cSSi]=size(SSi);
	for k=1:lSSi
		MSi=[MSi SSi(k,:)];
	end
	[lSSiD cSSiD]=size(SSiD);
	for k=1:lSSiD
		MSiD=[MSiD SSiD(k,:)];
	end
	M(1,1:length(MSi))=MSi;
	M(1,$)=length(MSi);
	M(2,1:length(MSiD))=MSiD;
	M(2,$)=length(MSiD);
	for i=3:n//find the site where node [X(i) Y(i)] belongs to
		intM=zeros(n,2*(3*n-6)+1);
		Mi=[];
		indi=[];
		D=[];
		bool=%F;
		for j=1:i-1
			D=[D NL_F_DistanceSiDj(X(i),Y(i),X(j),Y(j))];	
		end
		[mD iD]=min(D);//iD index of the site
		Pc=M(iD,1:M(iD,$));			
		[ac,bc]=NL_F_Bisection(X(iD),Y(iD),X(i),Y(i));
		[I,IF]=NL_F_InterPolygonLine(Pc,ac,bc,Lx,Ly,Dpres);
		path=IF;//if first point and last point belongs to the rectangle border, stop: bool=%T
		pdebx=path(1);
		pdeby=path(2);
		pfinx=path($-1);
		pfiny=path($);
		[bdeb,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pdebx,pdeby,Dpres);
		[bfin,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pfinx,pfiny,Dpres);
		if (bdeb==%T)&(bfin==%T)
			bool=%T
		end
		Si=[pdebx pdeby;pfinx pfiny];
		SiD=[pdebx pdeby;pfinx pfiny];
		for k=1:length(Pc)/2
			scx=Pc(2*(k-1)+1);
			scy=Pc(2*k);
			dsi=NL_F_DistanceSiDj(X(i),Y(i),scx,scy);
			dsiD=NL_F_DistanceSiDj(X(iD),Y(iD),scx,scy);
			if (dsi<dsiD)
				Si=[Si;scx scy];
			else
				SiD=[SiD;scx scy];
			end
		end
		SSi=NL_V_GrahamScan(Si);
		SSiD=NL_V_GrahamScan(SiD);
		MSi=[];
		MSiD=[];
		[lSSi cSSi]=size(SSi);
		for k=1:lSSi
			MSi=[MSi SSi(k,:)];
		end
		[lSSiD cSSiD]=size(SSiD);
		for k=1:lSSiD
			MSiD=[MSiD SSiD(k,:)];
		end	
		intM(iD,1:length(MSiD))=MSiD;
		intM(iD,$)=length(MSiD);
		Mi=[Mi MSi];
		indi=[indi iD];
		//propagate the segment
		while (bool==%F)
			iD0=iD;
			idebM=[];
			ifinM=[];
			[bdeb,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pdebx,pdeby,Dpres);
			if (bdeb==%T)
				idebM=[idebM 0];
			end
			[bfin,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pfinx,pfiny,Dpres);
			if (bfin==%T)
				ifinM=[ifinM 0];
			end
			for j=1:i-1
				[b,x1,y1,x2,y2]=NL_F_PointOfPolygon(M(j,1:M(j,$)),pdebx,pdeby,Dpres);
				if (b==%T)
					idebM=[idebM j];
				end
				[b,x1,y1,x2,y2]=NL_F_PointOfPolygon(M(j,1:M(j,$)),pfinx,pfiny,Dpres);
				if (b==%T)
					ifinM=[ifinM j];
				end
			end
			if (length(find(idebM<>0))==2)//not arrived in the border
				[iD]=NL_F_RemoveFirstOcc(idebM,indi(1));
				[ac,bc]=NL_F_Bisection(X(iD),Y(iD),X(i),Y(i));
				Pc=M(iD,1:M(iD,$));			
				[I,IF]=NL_F_InterPolygonLine(Pc,ac,bc,Lx,Ly,Dpres);
				if (NL_F_DistanceSiDj(IF(1),IF(2),pdebx,pdeby)<NL_F_DistanceSiDj(IF(3),IF(4),pdebx,pdeby))				
					IFn=[IF(3) IF(4)];			
				else
					IFn=[IF(1) IF(2)];
				end	
				path=[IFn path];
				pdebx=IFn(1);
				pdeby=IFn(2);
				Si=[IF(1:2);IF(3:4)];
				SiD=[IF(1:2);IF(3:4)];
				for k=1:length(Pc)/2
					scx=Pc(2*(k-1)+1);
					scy=Pc(2*k);
					dsi=NL_F_DistanceSiDj(X(i),Y(i),scx,scy);
					dsiD=NL_F_DistanceSiDj(X(iD),Y(iD),scx,scy);
					if (dsi<dsiD)
						Si=[Si;scx scy];
					else
						SiD=[SiD;scx scy];
					end
				end
				SSi=NL_V_GrahamScan(Si);
				SSiD=NL_V_GrahamScan(SiD);
				MSi=[];
				MSiD=[];	
				[lSSi cSSi]=size(SSi);
				for k=1:lSSi
					MSi=[MSi SSi(k,:)];
				end
				[lSSiD cSSiD]=size(SSiD);
				for k=1:lSSiD
					MSiD=[MSiD SSiD(k,:)];
				end
				Mi=[Mi MSi];
				indi=[iD indi];	
				intM(iD,1:length(MSiD))=MSiD;
				intM(iD,$)=length(MSiD);
			end 
			if (length(find(ifinM<>0))==2)//not arrived in the border
				[iD]=NL_F_RemoveFirstOcc(ifinM,indi($));
				[ac,bc]=NL_F_Bisection(X(iD),Y(iD),X(i),Y(i));
				Pc=M(iD,1:M(iD,$));			
				[I,IF]=NL_F_InterPolygonLine(Pc,ac,bc,Lx,Ly,Dpres);
				if (NL_F_DistanceSiDj(IF(1),IF(2),pfinx,pfiny)<NL_F_DistanceSiDj(IF(3),IF(4),pfinx,pfiny))				
					IFn=[IF(3) IF(4)];			
				else
					IFn=[IF(1) IF(2)];

				end
				path=[path IFn];
				pfinx=IFn(1);
				pfiny=IFn(2);
				Si=[IF(1:2);IF(3:4)];
				SiD=[IF(1:2);IF(3:4)];
				for k=1:length(Pc)/2
					scx=Pc(2*(k-1)+1);
					scy=Pc(2*k);
					dsi=NL_F_DistanceSiDj(X(i),Y(i),scx,scy);
					dsiD=NL_F_DistanceSiDj(X(iD),Y(iD),scx,scy);
					if (dsi<dsiD)
						Si=[Si;scx scy];
					else
						SiD=[SiD;scx scy];
					end
				end
				SSi=NL_V_GrahamScan(Si);
				SSiD=NL_V_GrahamScan(SiD);
				MSi=[];
				MSiD=[];	
				[lSSi cSSi]=size(SSi);
				for k=1:lSSi
					MSi=[MSi SSi(k,:)];
				end
				[lSSiD cSSiD]=size(SSiD);
				for k=1:lSSiD
					MSiD=[MSiD SSiD(k,:)];
				end	
				intM(iD,1:length(MSiD))=MSiD;
				intM(iD,$)=length(MSiD);
				Mi=[Mi MSi];
				indi=[indi iD];
			end
			[bdeb,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pdebx,pdeby,Dpres);
			[bfin,xx1,yy1,xx2,yy2]=NL_F_PointOfPolygon([0 0 Lx 0 Lx Ly 0 Ly],pfinx,pfiny,Dpres);
			if (bdeb==%T)&(bfin==%T)
				bool=%T
			end
		end
		MMi=path;
		cand=[0 0;Lx 0;Lx Ly;0 Ly];
		Dcand=[];
		for kkk=1:4
			cx=cand(kkk,1);
			cy=cand(kkk,2);
			Dcandi=[];
			for ik=1:i//
				Dcandi=[Dcandi NL_F_DistanceSiDj(cx,cy,X(ik),Y(ik))];
			end
			[vDcandi iDcandi]=min(Dcandi);
			Dcand=[Dcand iDcandi];
		end
		ic=find(Dcand==i);
		Rcand=[];
		iRcand=length(ic);
		DRcand=[];//distance to the end of the path
		for kkk=1:length(ic)
			Rcand=[Rcand;cand(ic(kkk),:)];//vertex of the border belonging to polygone i
			DRcand=[DRcand NL_F_DistanceSiDj(cand(ic(kkk),1),cand(ic(kkk),2),path($-1),path($))];
		end
		if (iRcand==1)
			MMi=[MMi Rcand];
		else
			allcand=1:iRcand;			
			[vo io]=min(DRcand);
			MMi=[MMi Rcand(io,:)];
			if (io==1)
				MMi=[MMi Rcand(2,:)];
			else
				MMi=[MMi Rcand(1,:)];
			end
		end
		M(i,1:length(MMi))=MMi;
		M(i,$)=length(MMi);
		for k=1:length(indi)
			M(indi(k),:)=intM(indi(k),:);
		end
	end
	Mmax=max(M(:,$));
	M=[M(:,1:Mmax) M(:,$)];
endfunction
