function [semimajor_axis, semiminor_axis, x0, y0, phi] = NL_V_FitEllipse(x,y)
	[lhs,rhs]=argn();
	lhsn=5;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[semimajor_axis, semiminor_axis, x0, y0, phi] = NL_V_FitEllipse(x,y)";
		help('NL_V_FitEllipse');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	n=length(x);
	M = [2*x.*y y.^2 2*x 2*y ones(n,1)];
	e = M\(-x.^2);
	a = 1;
	b = e(1);
	c = e(2);
	d = e(3);
	f = e(4);
	g = e(5);
	delta = b^2-a*c;
	x0 = (c*d - b*f)/delta;
	y0 = (a*f - b*d)/delta;
	phi = 0.5 * acot((c-a)/(2*b));
	nom = 2 * (a*f^2 + c*d^2 + g*b^2 - 2*b*d*f - a*c*g);
	s = sqrt(1 + (4*b^2)/(a-c)^2);
	a_prime = sqrt(nom/(delta* ( (c-a)*s -(c+a))));
	b_prime = sqrt(nom/(delta* ( (a-c)*s -(c+a))));
	semimajor_axis = max(a_prime, b_prime);
	semiminor_axis = min(a_prime, b_prime);
	if (a_prime < b_prime)
		phi = %pi/2 - phi;
	end
endfunction
